﻿module ivan_set;

private import std.c.stdio;

//version = AsocArray;
//version = treeSet;

version(treeSet)
{
	import std.stdio;
	import mintl.sortedaa;
	class set(SetType)
	{
		alias SortedAA!(SetType,int) ArrayAsc;
		private ArrayAsc skup;
		public bool insert(in SetType a)
		{
			bool inserted=false;
			if(!skup.opIn(a)){skup[a]=0;inserted = true;}
			return inserted;
		}
		public SetType[] Values() {return skup.keys;}
		public int length()
		{
			return skup.length;
		}
		public bool insert(in set a)
		{
			bool inserted = false;
			foreach(SetType val; a.Values())
				if(!skup.opIn(val)){skup[val]=0;inserted = true;}
			return inserted;
		}
		public bool contains(in SetType a)
		{
			return cast(bool)skup.opIn(a);
		}
		SetType opIndex (int x)
		{   
			assert(x>=0 && x<skup.length);
			int pos = 0;
			foreach( inout SetType key; skup.keys())
			{
				if(pos==x)return key;
				pos++;
			}
		}
		public this() {skup = *new ArrayAsc;}
		public this(in set a)
		{
			skup = *new ArrayAsc;
			foreach(SetType elem; a.Values()) 
			{
				this.insert(elem);
			}
		}
		public set dup()
		{
			set s = new set();
			s.skup = this.skup.dup;
			return s;
		}
		public void clear()
		{
			skup = *new ArrayAsc;
		}
		public int opEquals (in set x)
		{
			return this.skup==x.skup;
		}
	}
}
else
{
class set(SetType)
{
	typedef int[SetType] ArrayAsc;
	public this() {}
	public this(in set a)
	{
		foreach(SetType elem; a.Values()) 
		{
			this.insert(elem);
		}
	}
	bool find(inout SetType a)
	{
		for(int i=0; i<skup.length; i++)
		{
			if(skup[i]==a)
			{a = skup[i];
			return true;
			}
		}
		return false;
	}
	SetType opIndex (int x)
	{   
		assert(x>=0 && x<skup.length);
		return skup[x];
	}
	template transform(FUNC)
	{
		static FUNC transform(FUNC f,inout set a)
		{
			foreach(inout SetType elem; a)
			{
				elem = f(elem);
			}
			return f;
		}
	}
	public this(in SetType[] array)
	{
		for(int i=0; i<array.length; i++)
			this.insert(array[i]);
	}
	public int opEquals (in set x)
	{
		return Eq(this,x);
	}
	public set opAdd (in set x)
	{
		set novi = new set(this);

		foreach(SetType n; x.Values())
			novi.insert(n);

		return novi;
	}

	public set dup()
	{
		set s = new set();
		version(AsocArray)
		{
			foreach(SetType e; skup.keys)
				s.insert(e);			
		}
		else
		{
			foreach(SetType e; skup)
				s.insert(e);
		}
		return s;
	}
	public set opMul (in set x)
	{
		set newset = new set();

		foreach(SetType elem; this.Values()) 
		{
			if(x.contains(elem))
				newset.insert(elem);
		}
		return newset;
	}

	public void clear()
	{
		version(AsocArray)
		{
			foreach(SetType t; skup.keys)
				delete skup[t];
		}
		else
		{
			skup.length = 0;
		}
	}
	public bool remove(in SetType a)
	{
		version(AsocArray)
		{
			if(a in skup)
			{
				delete skup[a];
				return true;
			}
			else return false;
		}
		else
		{
			for(int i=0; i<skup.length; i++)
			{
				if(skup[i]==a)
				{
					skup = skup[0..i] ~skup[i+1..skup.length];
					return true;
				}
			}
			return false;
		}
	}
	public bool remove(in SetType[] a)
	{
		bool removed = false;
		foreach(SetType val; a)
			removed |= this.remove(val);
		return removed;	
	}
	public bool insert(in SetType a)
	{
		version(AsocArray)
		{
			if(!(a in skup)) {skup[a]=1; return true;}
			else return false;
		}
		else
		{
			if(!(this.contains(a))){this.skup~=a; return true;}
			return false;
		}
	}
	public bool insert(in SetType[] a)
	{
		bool inserted = false;
		foreach(SetType val; a)
			inserted |= this.insert(val);
		return inserted;
	}
	public bool insert(in set a)
	{
		bool inserted = false;
		foreach(SetType val; a.Values())
			inserted |= this.insert(val);
		return inserted;
	}
	public static bool Eq(in set a, in set b)
	{
		foreach(SetType iza; a.Values())
			if(!b.contains(iza))return false;

		foreach(SetType izb; b.Values())
			if(!a.contains(izb))return false;

		return true;
	}
	
	public bool contains(in SetType a)
	{
		version(AsocArray)
		{
			if(a in skup)return true;
			else return false;
		}
		else
		{
			foreach(inout SetType e; skup)
			{
				if(e==a)return true;
			}
			return false;
		}
	}
	
	public int length()
	{
		return skup.length;
	}
	
	version(AsocArray)
		public SetType[] Values() {return skup.keys;}
	else
		public SetType[] Values() {return skup;}
	
	version(AsocArray)
		private int[SetType] skup;
	else
		private SetType[] skup;
 
	unittest
	{
		{//TEST .set!(int)
			.set!(int) set1 = new .set!(int);
			assert(set1.insert(1) == true);
			assert(set1.length == 1);
			assert(set1.insert(3) == true);
			assert(set1.length == 2);
			int[] numbers = new int[10];
			for(int i=0; i<numbers.length; i++)
				numbers[i]=i;
			
			assert(set1.insert(numbers) == true);
			
			.set!(int) set2 = new .set!(int)(set1);
			assert(set2.length == 10); //0 1 2 3 4 5 6 7 8 9
			
			assert(set1.length == 10); //0 1 2 3 4 5 6 7 8 9
			
			numbers.length = 5;
			assert(set1.remove(numbers) == true);
			assert(set1.length == 5); //5 6 7 8 9
			
			.set!(int) setUnion = set1 + set2;
			assert(setUnion.length == 10);
			for(int i=0; i<setUnion.length; i++)
				assert(setUnion.contains(i) == true);
		}
		{//TEST .set!(AB)
			class AB
			{
				public this(int br){this.x=br;}
				public int x;
				int opEquals (AB drugi)  {   return this.x==drugi.x; }
				int opCmp (AB drugi)
				{ 
					if(this.x < drugi.x)return -1;
					if(this.x > drugi.x)return 1;
					if(this.x == drugi.x)return 0;
				}
			}
			.set!(AB) ABset1 = new .set!(AB);
			AB a5 = new AB(5); 
			AB b7 = new AB(7);
			AB c5 = new AB(5);
			assert(a5 == c5);
			assert(a5 != b7);
			assert(b7 != c5);
			
			printf("\na5 == c5 = %d",a5==c5);
			printf("\na5 < c5 = %d",a5 < a5);
			printf("\na5 > c5 = %d",a5 > a5);
			printf("\na5 < b7 = %d",a5 < b7);
			printf("\na5 > b7 = %d",a5 > b7);

			
			ABset1.insert(a5);
			ABset1.insert(b7);
			assert(ABset1.length == 2);

			assert(ABset1.contains(a5));
			assert(ABset1.contains(b7));
			assert(ABset1.contains(c5));
			assert(ABset1.contains(new AB(5)));
			assert(ABset1.contains(new AB(7)));
			assert(!ABset1.contains(new AB(4)));
			assert(ABset1.length == 2);
			
			ABset1.insert(new AB(7));
			assert(ABset1.length == 2);
		}
		
		printf("\nUnittest OK!");
	}
}
}//end version else

//AšAŠAđAĐAčAČAćAĆAžAŽA  ĈĉĜĝĤĥŬŭĵĴŜŝ
